
//
// gomokuMCspeler.cc
// Roy van Hal en Walter Kosters
// 26 maart 2019
//

const int MCSPELLEN = 200;

class MCspeler : public Basisspeler {
public:
  int speelRandomSpel (gomoku & randomspel);
  MCspeler (gomoku* spelPointer);
  int volgendeZet ( );
};//MCspeler

// constructor
MCspeler::MCspeler (gomoku* spelPointer) {
  spel = spelPointer;
}//MCspeler::MCspeler

// speel een random spel uit
int MCspeler::speelRandomSpel (gomoku & randomspel) {
  while ( ! randomspel.finished ( ) ) {
    randomspel.dothemove (rand ( ) % randomspel.numberofmoves ( ) + 1);
  }//while
  return (randomspel.gamestatus ( ));
}//MCSpeler::speelRandomSpel

// de beste Monte Carlo zet
int MCspeler::volgendeZet ( ) {
  gomoku kopie;
  int huidigeScore;
  int besteZet = 1;
  int besteScore = -1;
  int aantal = spel->numberofmoves ( );
  for ( int i = 1; i <= aantal; i++ ) {
    huidigeScore = 0;
    for ( int k = 0; k < MCSPELLEN; k++ ) {
      kopie = *spel;
      kopie.dothemove(i);
      if ( speelRandomSpel (kopie) == spel->whois ( ) ) {
        huidigeScore++;
      }//if
    }//for
    if ( huidigeScore > besteScore ) {
      besteZet = i;
      besteScore = huidigeScore;
    }//if
  }//for
  return besteZet;
}//MCspeler::volgendeZet

